# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Customvisiontraining::V3_0
  module Models
    #
    # Iteration model to be sent over JSON.
    #
    class Iteration

      include MsRestAzure

      # @return Gets the id of the iteration.
      attr_accessor :id

      # @return [String] Gets or sets the name of the iteration.
      attr_accessor :name

      # @return [String] Gets the current iteration status.
      attr_accessor :status

      # @return [DateTime] Gets the time this iteration was completed.
      attr_accessor :created

      # @return [DateTime] Gets the time this iteration was last modified.
      attr_accessor :last_modified

      # @return [DateTime] Gets the time this iteration was last modified.
      attr_accessor :trained_at

      # @return Gets the project id of the iteration.
      attr_accessor :project_id

      # @return [Boolean] Whether the iteration can be exported to another
      # format for download.
      attr_accessor :exportable

      # @return [Array<Enum>] A set of platforms this iteration can export to.
      attr_accessor :exportable_to

      # @return Get or sets a guid of the domain the iteration has been trained
      # on.
      attr_accessor :domain_id

      # @return [Classifier] Gets the classification type of the project.
      # Possible values include: 'Multiclass', 'Multilabel'
      attr_accessor :classification_type

      # @return [TrainingType] Gets the training type of the iteration.
      # Possible values include: 'Regular', 'Advanced'
      attr_accessor :training_type

      # @return [Integer] Gets the reserved advanced training budget for the
      # iteration.
      attr_accessor :reserved_budget_in_hours

      # @return [String] Name of the published model.
      attr_accessor :publish_name

      # @return [String] Resource Provider Id this iteration was originally
      # published to.
      attr_accessor :original_publish_resource_id


      #
      # Mapper for Iteration class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Iteration',
          type: {
            name: 'Composite',
            class_name: 'Iteration',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              created: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'created',
                type: {
                  name: 'DateTime'
                }
              },
              last_modified: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'lastModified',
                type: {
                  name: 'DateTime'
                }
              },
              trained_at: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'trainedAt',
                type: {
                  name: 'DateTime'
                }
              },
              project_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'projectId',
                type: {
                  name: 'String'
                }
              },
              exportable: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'exportable',
                type: {
                  name: 'Boolean'
                }
              },
              exportable_to: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'exportableTo',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'enumElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              domain_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'domainId',
                type: {
                  name: 'String'
                }
              },
              classification_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'classificationType',
                type: {
                  name: 'String'
                }
              },
              training_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'trainingType',
                type: {
                  name: 'String'
                }
              },
              reserved_budget_in_hours: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'reservedBudgetInHours',
                type: {
                  name: 'Number'
                }
              },
              publish_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'publishName',
                type: {
                  name: 'String'
                }
              },
              original_publish_resource_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'originalPublishResourceId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
